/**
 * @license
 * Copyright Tyler Technologies, Inc. 
 * License: Apache-2.0
 */
import { ICustomElementFoundation } from '@tylertech/forge-core';
import { IBaseDrawerAdapter } from './base-drawer-adapter';
import { DrawerDirection } from './base-drawer-constants';
export interface IBaseDrawerFoundation extends ICustomElementFoundation {
    direction: DrawerDirection;
}
export declare class BaseDrawerFoundation implements IBaseDrawerFoundation {
    protected _adapter: IBaseDrawerAdapter;
    protected _open: boolean;
    protected _direction: DrawerDirection;
    private _hasInitialized;
    private _openAnimationListener;
    private _closeAnimationListener;
    constructor(_adapter: IBaseDrawerAdapter);
    connect(): void;
    disconnect(): void;
    private _applyDirection;
    private _onOpenComplete;
    private _onCloseComplete;
    private _setOpened;
    private _setClosed;
    protected _applyOpen(): void;
    protected _triggerDrawerOpen(): void;
    protected _triggerDrawerClose(): void;
    get open(): boolean;
    set open(value: boolean);
    get direction(): DrawerDirection;
    set direction(value: DrawerDirection);
}
